<?php
namespace Teknisa\FIS\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIS\Factories\Ger01500MunicipioFactory;

class Ger01500MunicipioService{
    protected $dataSourceManager;
    protected $ger01500municipiofactory;
    protected $environment;

    public function __construct($dataSourceManager, $ger01500municipiofactory, Environment $environment){
        $this->dataSourceManager = $dataSourceManager;
        $this->ger01500municipiofactory = $ger01500municipiofactory;
        $this->environment = $environment;
    }

    public function saveMunicipio($row){
        if($row['__is_new']){
            $this->verficaCodigoMunicipio($row);
        }
        $this->verficaNomeMunicipio($row);
        $array[] = $row;
        $dataSet = new DataSet('municipio', $array);
        $this->dataSourceManager->persist($dataSet);
    }

    //não permite salvar estado com mesmo nome para um mesmo pais
    public function verficaNomeMunicipio($row){
        $resultadoBanco = $this->ger01500municipiofactory->verficaNomeMunicipio($row);
        if(!empty ($resultadoBanco) ){
            // no caso de edição para verificar se o ESTADO ja existe na base e está sendo editado
            if($resultadoBanco[0]['CDMUNICIPIO']  !== $row['CDMUNICIPIO']){
                throw new \Exception("Nome já cadastrado.", 1);

            }
        }
    }
    
    public function verficaCodigoMunicipio($row){
        $resultadoBanco = $this->ger01500municipiofactory->verficaCodigoMunicipio($row);
        if(!empty($resultadoBanco)){
            throw new \Exception("Código já cadastrado.", 1);
        }
    }
    
    public function novoCodigoBairro($row){
        return  $this->ger01500municipiofactory->novoCodigoBairro($row['CDPAIS'], $row['SGESTADO'], $row['CDMUNICIPIO']);
    }
    
    public function novoCodigoRegiao($row){
        return  $this->ger01500municipiofactory->novoCodigoRegiao($row['CDPAIS'], $row['SGESTADO'], $row['CDMUNICIPIO']);
        
    }
    
}