/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUCOTA                                                      */
/* Tabela : CONTATO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 19/06/2006 - Eduardo H. c. Ramos                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUCOTA
BEFORE INSERT OR UPDATE OR DELETE
ON CONTATO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCOTA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0    ) <> NVL(:NEW.CDFILIAL,0    )) OR
         (NVL(:OLD.NRCONTATO,0   ) <> NVL(:NEW.NRCONTATO,0   ))THEN
         :NEW.DTULTATUCOTA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONTATO', '', 'NRCONTATO='||:OLD.NRCONTATO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONTATO MODIFY DTULTATUCOTA DEFAULT SYSDATE
/